---
title: 'Window: popstate event'
slug: Web/API/Window/popstate_event
tags:
  - API
  - Event
  - HTML DOM
  - History
  - History API
  - Location
  - Navigation
  - Reference
  - URL
  - Window
  - popstate
---
<p>{{APIRef}}</p>

<p>The <strong><code>popstate</code></strong> event of the {{domxref("Window")}} interface is fired when the active history entry changes while the user navigates the session history. It changes the current history entry to that of the last page the user visited or, if {{domxref("history.pushState()")}} has been used to add a history entry to the history stack, that history entry is used instead.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("PopStateEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("WindowEventHandlers.onpopstate", "onpopstate")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="The_history_stack">The history stack</h2>

<p>If the history entry being activated was created by a call to <code><a href="/en-US/docs/Web/API/History_API#The_pushState()_method">history.pushState()</a></code> or was affected by a call to <code><a href="/en-US/docs/Web/API/History_API#The_replaceState()_method">history.replaceState()</a></code>, the <code>popstate</code> event's <code>state</code> property contains a copy of the history entry's state object.</p>

<p>These methods and their corresponding events can be used to add data to the history stack which can be used to reconstruct a dynamically generated page, or to otherwise alter the state of the content being presented while remaining on the same {{domxref("Document")}}.</p>

<p>Note that just calling <code>history.pushState()</code> or <code>history.replaceState()</code> won't trigger a <code>popstate</code> event. The <code>popstate</code> event will be triggered by doing a browser action such as a click on the back or forward button (or calling <code>history.back()</code> or <code>history.forward()</code> in JavaScript).</p>

<p>Browsers tend to handle the <code>popstate</code> event differently on page load. Chrome (prior to v34) and Safari always emit a <code>popstate</code> event on page load, but Firefox doesn't.</p>

<div class="notecard note">
<p><strong>Note</strong>: When writing functions that process <code>popstate</code> event it is important to take into account that properties like <code>window.location</code> will already reflect the state change (if it affected the current URL), but <code>document</code> might still not. If the goal is to catch the moment when the new document state is already fully in place, a zero-delay {{domxref("WindowOrWorkerGlobalScope.setTimeout", "setTimeout()")}} method call should be used to effectively put its inner <em>callback</em> function that does the processing at the end of the browser event loop: <code>window.</code><code>onpopstate</code><code> = () =&gt; setTimeout(doSomeThing, 0);</code></p>
</div>

<h2 id="When_popstate_is_sent">When popstate is sent</h2>

<p>When the transition occurs, either due to the user triggering the browser's "Back" button or otherwise, the <code>popstate</code> event is near the end of the process to transition to the new location. It happens after the new location has loaded (if needed), displayed, made visible, and so on, after the {{domxref("Document.pageshow_event", "pageshow")}} event is sent, but before the persisted user state information is restored and the {{domxref("Window.hashchange_event", "hashchange")}} event is sent.</p>

<p>To better understand when the <code>popstate</code> event is fired, consider this simplified sequence of events that occurs when the current history entry changes due to either the user navigating the site or the history being traversed programmatically. Here, the transition is changing the current history entry to one we'll refer to as <strong>new-entry</strong>. The current page's session history stack entry will be referred to as <strong>current-entry</strong>.</p>

<ol>
 <li>If <strong>new-entry</strong> doesn't currently contain an existing {{domxref("Document")}}, fetch the content and create its <code>Document</code> before continuing. This will eventually send events such as {{domxref("Window.DOMContentLoaded_event", "DOMContentLoaded")}} and {{domxref("Window.load_event", "load")}} to the {{domxref("Window")}} containing the document, but the steps below will continue to execute in the meantime.</li>
 <li>If <strong>current-entry</strong>'s title wasn't set using one of the History API methods ({{domxref("History.pushState", "pushState()")}} or {{domxref("History.replaceState", "replaceState()")}}, set the entry's title to the string returned by its {{domxref("document.title")}} attribute.</li>
 <li>If the browser has state information it wishes to store with the <strong>current-entry</strong> before navigating away from it, it then does so. The entry is now said to have "persisted user state." This information the browser might add to the history session entry may include, for instance, the document's scroll position, the values of form inputs, and other such data.</li>
 <li>If <strong>new-entry</strong> has a different <code>Document</code> object than <strong>current-entry</strong>, the browsing context is updated so that its {{domxref("Window.document", "document")}} property refers to the document referred to by <strong>new-entry</strong>, and the context's name is updated to match the context name of the now-current document.</li>
 <li>Each form control within <strong>new-entry</strong>'s {{domxref("Document")}} that has {{htmlattrxref("autocomplete", "input")}} configured with its autofill field name set to <code>off</code> is reset. See <a href="/en-US/docs/Web/HTML/Attributes/autocomplete">The HTML autocomplete attribute</a> for more about the autocomplete field names and how autocomplete works.</li>
 <li>If <strong>new-entry</strong>'s document is already fully loaded and ready—that is, its {{domxref("Document.readyState", "readyState")}} is <code>complete</code>—and the document is not already visible, it's made visible and the {{domxref("Document.pageshow_event", "pageshow")}} event is fired at the document with the {{domxref("PageTransitionEvent")}}'s {{domxref("PageTransitionEvent.persisted", "persisted")}} attribute set to <code>true</code>.</li>
 <li>The document's {{domxref("Document.URL", "URL")}} is set to that of <strong>new-entry</strong>.</li>
 <li>If the history traversal is being performed with replacement enabled, the entry immediately prior to the destination entry (taking into account the <code>delta</code> parameter on methods such as {{domxref("History.go", "go()")}}) is removed from the history stack.</li>
 <li>If the <strong>new-entry</strong> doesn't have persisted user state and its URL's fragment is non-<code>null</code>, the document is scrolled to that fragment.</li>
 <li>Next, <strong>current-entry</strong> is set to <strong>new-entry</strong>. The destination entry is now considered to be current.</li>
 <li>If <strong>new-entry</strong> has serialized state information saved with it, that information is deserialized into {{domxref("History.state")}}; otherwise, <code>state</code> is <code>null</code>.</li>
 <li><span style="color: #229922;">If the value of <code>state</code> changed, the <code>popstate</code> event is sent to the document.</span></li>
 <li>Any persisted user state is restored, if the browser chooses to do so.</li>
 <li>If the original and new entry's shared the same document, but had different fragments in their URLs, send the {{domxref("Window.hashchange_event", "hashchange")}} event to the window.</li>
</ol>

<p>As you can see, the <code>popstate</code> event is nearly the last thing done in the process of navigating pages in this way.</p>

<h2 id="Examples">Examples</h2>

<p>A page at <code>http://example.com/example.html</code> running the following code will generate logs as indicated:</p>

<pre class="brush: js notranslate">window.addEventListener('popstate', (event) =&gt; {
  console.log("location: " + document.location + ", state: " + JSON.stringify(event.state));
});
history.pushState({page: 1}, "title 1", "?page=1");
history.pushState({page: 2}, "title 2", "?page=2");
history.replaceState({page: 3}, "title 3", "?page=3");
history.back(); // Logs "location: http://example.com/example.html?page=1, state: {"page":1}"
history.back(); // Logs "location: http://example.com/example.html, state: null"
history.go(2);  // Logs "location: http://example.com/example.html?page=3, state: {"page":3}"
</pre>

<p>The same example using the <code>onpopstate</code> event handler property:</p>

<pre class="brush: js notranslate">window.onpopstate = function(event) {
  console.log("location: " + document.location + ", state: " + JSON.stringify(event.state));
};
history.pushState({page: 1}, "title 1", "?page=1");
history.pushState({page: 2}, "title 2", "?page=2");
history.replaceState({page: 3}, "title 3", "?page=3");
history.back(); // Logs "location: http://example.com/example.html?page=1, state: {"page":1}"
history.back(); // Logs "location: http://example.com/example.html, state: null"
history.go(2);  // Logs "location: http://example.com/example.html?page=3, state: {"page":3}"
</pre>

<p>Note that even though the original history entry (for <code>http://example.com/example.html</code>) has no state object associated with it, a <code>popstate</code> event is still fired when we activate that entry after the second call to <code>history.back()</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'indices.html#event-popstate', 'popstate')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.popstate_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/History_API">Manipulating the browser history (the History API)</a></li>
 <li><a href="/en-US/docs/Web/API/Window/hashchange_event">Window: <code>hashchange</code> event</a></li>
</ul>
